Gecode::RBS< T, E > Class Template Reference
Functionality by programming task » Programming models » Search engines

Meta-engine performing restart-based search. More...

`#include <search.hh>`

## Public Member Functions

| RBS (T *s, const Search::Options &o)
| Initialize engine for space s and options o.
Public Member Functions inherited from Gecode::Search::Base< T >
virtual T * | next (void)
| Return next solution (NULL, if none exists or search has been stopped).
virtual Statistics | statistics (void) const
| Return statistics.
virtual bool | stopped (void) const
| Check whether engine has been stopped.
virtual | ~Base (void)
| Destructor.

## Static Public Attributes

static const bool | best = E<T>::best
| Whether engine does best solution search.

## Additional Inherited Members

Static Public Member Functions inherited from Gecode::HeapAllocated
static void * | operator new (size_t s)
| Memory management.
static void | operator delete (void *p)
| Free memory allocated from heap.
Protected Member Functions inherited from Gecode::Search::Base< T >
| Base (Engine *e=NULL)
| Constructor.
Protected Attributes inherited from Gecode::Search::Base< T >
Engine * | e
| The actual search engine.

## Detailed Description

template<class T, template< class > class E = DFS>
class Gecode::RBS< T, E >

Meta-engine performing restart-based search.

The engine uses the Cutoff sequence supplied in the options o to periodically restart the search of engine E.

The class T can implement member functions

virtual bool master(const MetaInfo& mi)
Gecode::MetaInfo
Information passed by meta search engines.
Definition core.hpp:1613

and

virtual bool slave(const MetaInfo& mi)

Whenever exploration restarts or a solution is found, the engine executes the functions on the master and slave space. For more details, consult "Modeling and Programming with Gecode".

Definition at line 1152 of file search.hh.

## Constructor & Destructor Documentation

## RBS()

template<class T, template< class > class E>

Gecode::RBS< T, E >::RBS | ( | T * | s,
|  | const Search::Options & | o )

inline

Initialize engine for space s and options o.

Definition at line 83 of file rbs.hpp.

## Member Data Documentation

## best

template<class T, template< class > class E = DFS>

const bool Gecode::RBS< T, E >::best = E<T>::best

static

Whether engine does best solution search.

Definition at line 1158 of file search.hh.

The documentation for this class was generated from the following files:

- gecode/search.hh
- gecode/search/rbs.hpp